    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * NumberCellRenderer.java
    029     * -----------------------
    030     * (C) Copyright 2000-2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: NumberCellRenderer.java,v 1.5 2005/11/03 09:27:09 mungady Exp $
    036     *
    037     * Changes (from 26-Oct-2001)
    038     * --------------------------
    039     * 26-Oct-2001 : Changed package to com.jrefinery.ui.*;
    040     * 11-Mar-2002 : Updated import statements (DG);
    041     *
    042     */
    043
    044    package org.jfree.ui;
    045
    046    import java.awt.Component;
    047    import java.text.NumberFormat;
    048
    049    import javax.swing.JTable;
    050    import javax.swing.SwingConstants;
    051    import javax.swing.table.DefaultTableCellRenderer;
    052
    053    /**
    054     * A table cell renderer that formats numbers with right alignment in each cell.
    055     *
    056     * @author David Gilbert
    057     */
    058    public class NumberCellRenderer extends DefaultTableCellRenderer {
    059
    060        /**
    061         * Default constructor - builds a renderer that right justifies the
    062         * contents of a table cell.
    063         */
    064        public NumberCellRenderer() {
    065            super();
    066            setHorizontalAlignment(SwingConstants.RIGHT);
    067        }
    068
    069        /**
    070         * Returns itself as the renderer. Supports the TableCellRenderer interface.
    071         *
    072         * @param table  the table.
    073         * @param value  the data to be rendered.
    074         * @param isSelected  a boolean that indicates whether or not the cell is
    075         *                    selected.
    076         * @param hasFocus  a boolean that indicates whether or not the cell has
    077         *                  the focus.
    078         * @param row  the (zero-based) row index.
    079         * @param column  the (zero-based) column index.
    080         *
    081         * @return the component that can render the contents of the cell.
    082         */
    083        public Component getTableCellRendererComponent(final JTable table,
    084                final Object value, final boolean isSelected,
    085                final boolean hasFocus, final int row, final int column) {
    086
    087            setFont(null);
    088            final NumberFormat nf = NumberFormat.getNumberInstance();
    089            setText(nf.format(value));
    090            if (isSelected) {
    091                setBackground(table.getSelectionBackground());
    092            }
    093            else {
    094                setBackground(null);
    095            }
    096            return this;
    097        }
    098
    099    }